//
//  ViewController.m
//  Switch for GoPro HERO
//
//  Created by John Li on 23/01/2018.
//  Copyright © 2018 John Li. All rights reserved.
//

#import "ViewController.h"
#import "JSONKit.h"
#import "ColViewImage.h"
#import "MediaFile.h"
#import "ViewWindowController.h"
#import "Constants.h"
#import "GoProHelper.h"
#import "GCDAsyncUdpSocket.h"
#import "mylib.h"
#import "GoproDownloadFiles.h"

@interface ViewController (){
    BOOL continueSyncClicked;
    NSDateFormatter *dateFormatter;
    NSCollectionViewFlowLayout* layout;
    int iconWidth;
    
    NSString* camName;
    NSString* serial;
    NSString* mac;
    NSString* firmware;
    
    NSString* urlBitRate;
    NSString* urlSize;
    GoproDownloadFiles* cdf;
}
@property (weak) IBOutlet NSButton *btnSync;
@property (weak) IBOutlet NSProgressIndicator *progInd;
@property (weak) IBOutlet NSTextField *tfSyncStatus;
@property (weak) IBOutlet NSSliderCell *sliderSize;
@property NSString* syncPath;
@end

@implementation ViewController{
    GCDAsyncUdpSocket* udpSocket;
    NSMutableData* currentData;
}

extern int main234(int argc, char **argv);
extern int main556(int argc, char **argv);
extern void term_exit(void);

extern void sigterm_handler(int sig);

extern int received_sigterm;

-(void)startUDP{
    udpSocket = [[GCDAsyncUdpSocket alloc] initWithDelegate:self delegateQueue:dispatch_get_main_queue()];
    
    count = 0;
    NSError *error = nil;
    
    if (![udpSocket bindToPort:8554 error:&error])
    {
        //NSLog(@"Error binding: %@", error);
        return;
    }
    if (![udpSocket beginReceiving:&error])
    {
        //NSLog(@"Error receiving: %@", error);
        return;
    }
    //NSLog(@"bind ok");
}

- (void)udpSocket:(GCDAsyncUdpSocket *)sock didSendDataWithTag:(long)tag
{
    // You could add checks here
}

- (void)udpSocket:(GCDAsyncUdpSocket *)sock didNotSendDataWithTag:(long)tag dueToError:(NSError *)error
{
    // You could add checks here
}

int count;

- (void)udpSocket:(GCDAsyncUdpSocket *)sock didReceiveData:(NSData *)data
      fromAddress:(NSData *)address
withFilterContext:(id)filterContext
{
    //    <?xml version="1.0"?><funcidlist><funcid name="framesize"/><funcid name="afframeinfo"/><funcid name="mntmediainfo"/><funcid name="rotation"/><funcid name="maxtakenum"/><funcid name="temperror"/><funcid name="battempty"/><funcid name="shutspeedvalue"/><funcid name="focalvalue"/><funcid name="expcomp"/><funcid name="wbvalue"/><funcid name="isospeedvalue"/><funcid name="contnotstop"/><funcid name="aspectratio"/><funcid name="liveaddinfo"/><funcid name="expphotowarning"/><funcid name="focusinfo"/><funcid name="zoominfo"/><funcid name="maxmovietime"/><funcid name="nrimage"/><funcid name="recmovietime"/>
    count ++ ;
    if(data != nil){
//        //NSLog(@"data :%d , %d ,%d",(int)data.length,currentData.length,count);
    }
    
    if(data == nil || data.length < 16){
        return;
    }
    
    Byte* buf = data.bytes;
    
    int start = -1;
    for(int i=0;i<data.length;i++){
        if(buf[i] == 0xff && (i+1)<data.length && buf[i+1] == 0xD8){
            ////NSLog(@"start jpg");
            start = i;
            currentData = [NSMutableData dataWithData:[data subdataWithRange:NSMakeRange(start, data.length-start)]];
            return;
        }
    }
    
    int end = -1;
    for(int i=0;i<data.length;i++){
        if(buf[i] == 0xff && (i+1)<data.length && buf[i+1] == 0xD9){
            end = i + 1;
            [currentData appendData:[data subdataWithRange:NSMakeRange(0, end)]];
            //NSLog(@"img size %d",currentData.length);
            
            if(currentData.length >0 && currentData.length < 1024*1024*10){
                NSData* dt = [NSData dataWithData:currentData];
                //            //NSLog(@"img len %d",dt.length);
                dispatch_async(dispatch_get_main_queue(), ^{
                    NSImage* img = [[NSImage alloc] initWithData:dt];
                    
                                    //NSLog(@"set img %@ %d %d",img == nil?@"nil img":@"ok img",dt.length,count);
                    if(img != nil){
                        [self.imgView setImage:img];
                        [self.imgView setNeedsDisplay];
                        [self.imgView setNeedsLayout:YES];
                    }
                });
            }
            
            currentData = nil;
            return;
        }
    }
    
    [currentData appendData:data];
//    //NSLog(@"start %d , end %d",start,end);
    return;
    //parse data
    //    int start = -1;
    //    int end = -1;
    
    
    //    int byteData = buf[1];
    ////    int version = byteData >> 6 & 0x3;
    ////    int padding = byteData >> 5 & 0x1;
    //    int extension = byteData >> 4 & 0x1;
    //    if(extension == 1){
    //        //NSLog(@"skip 1st");
    //        return;
    //    }
    
    //    //NSLog(@"data size:%d",data.length);
    
    //    NSString* str = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    //    if(str != nil){
    //        //NSLog(@"-------%d",str.length);
    //    }
    
    //    for(int i=0;i<data.length - 4;i++){
    //        if(buf[i] == 0xff && buf[i+1] == 0xff && buf[i+2] == 0xff && buf[i+3] == 0xff){
    //            //NSLog(@"found ffff at %d",i);
    //        }
    //    }
    
    BOOL isEnd = NO;
    if(buf[0] == 0x90 && buf[1] == 0x60){
        //start [0x90, 0x60]
        //find start
        int start = -1;
        for(int i=0;i<data.length;i++){
            if(buf[i] == 0xff && (i+1)<data.length && buf[i+1] == 0xD8){
                ////NSLog(@"start jpg");
                start = i;
            }
        }
        
        if(start > 0){
            currentData = [NSMutableData dataWithData:[data subdataWithRange:NSMakeRange(start, data.length-start)]];
        }else{
            //NSLog(@"------------not start ? %d",data.length);
            return;
        }
    }else if(buf[0] == 0x80){
        //        [0x80, 0xe0]
        if(buf[1] == 0x60){
            //mid
            [currentData appendData:[data subdataWithRange:NSMakeRange(12, data.length - 12)]];
            return;
        }else{
            int end = -1;
            for(int i=0;i<data.length;i++){
                if(buf[i] == 0xff && (i+1)<data.length && buf[i+1] == 0xD9){
                    end = i + 1;
                }
            }
            if(end<0){
                //NSLog(@"-----------no end ? %d",data.length);
                return;
            }
            //end
            [currentData appendData:[data subdataWithRange:NSMakeRange(0, end)]];
            
            if(count % 20 != 0){
                return;
            }
            
            NSData* dt = [NSData dataWithData:currentData];
            //            //NSLog(@"img len %d",dt.length);
            dispatch_async(dispatch_get_main_queue(), ^{
                NSImage* img = [[NSImage alloc] initWithData:dt];
                
                //                //NSLog(@"set img %@ %d %d",img == nil?@"nil img":@"ok img",dt.length,count);
                if(img != nil){
                    [self.imgView setImage:img];
                    [self.imgView setNeedsDisplay];
                    [self.imgView setNeedsLayout:YES];
                }
            });
        }
    }
    
    ////NSLog(@"start end %d,%d , %d",start,end,data.length);
    
    //    if(start >= 0 && end < 0 && start<data.length){
    //        currentData = [NSMutableData dataWithData:[data subdataWithRange:NSMakeRange(start, data.length - start)]];
    //    }else if(end >= 0 && start < 0 && end<data.length){
    //        [currentData appendData:[data subdataWithRange:NSMakeRange(0, end)]];
    //
    //        NSData* dt = [NSData dataWithData:currentData];
    //
    //        count ++ ;
    //        if(count % 2 != 0){
    //            return;
    //        }
    //        dispatch_async(dispatch_get_main_queue(), ^{
    //            NSImage* img = [[NSImage alloc] initWithData:dt];
    //            ////NSLog(@"set img %@ %d %d",img == nil?@"nil img":@"ok img",dt.length,count);
    //            if(img != nil){
    //                [self.imgView setImage:img];
    //                [self.imgView setNeedsDisplay];
    //                [self.imgView setNeedsLayout:YES];
    //            }
    //        });
    //    }else if(end > start && start >= 0 && end<data.length){
    //        NSData* dt = [NSData dataWithData:currentData];
    //
    //        count ++ ;
    //        if(count % 2 != 0){
    //            return;
    //        }
    //        dispatch_async(dispatch_get_main_queue(), ^{
    //            NSImage* img = [[NSImage alloc] initWithData:dt];
    //            ////NSLog(@"set img2 %@ %d %d",img == nil?@"nil img":@"ok img",dt.length,count);
    //            if(img != nil){
    //                [self.imgView setImage:img];
    //                [self.imgView setNeedsDisplay];
    //                [self.imgView setNeedsLayout:YES];
    //            }
    //        });
    //    }else if(currentData != nil){
    //        [currentData appendData:data];
    //    }
}


- (IBAction)downloadSelectedFiles:(id)sender {
    cdf = [[GoproDownloadFiles alloc] initWithWindowNibName:@"GoproDownloadFiles"];
    NSIndexSet* nis = self.colViewPhoto.selectionIndexes;
    NSMutableArray* filesDown = [NSMutableArray new];
    [nis enumerateIndexesUsingBlock:^(NSUInteger idx, BOOL * _Nonnull stop) {
        [filesDown addObject:files[idx]];
    }];
    cdf.selectedFiles = filesDown;
    [cdf showWindow:self];
}

- (IBAction)selectAllClicked:(id)sender {
    if(self.colViewPhoto.selectionIndexes.count == files.count){
        [self.colViewPhoto deselectAll:nil];
    }else{
        [self.colViewPhoto selectAll:nil];
    }
}

- (void)viewDidLoad {
    [super viewDidLoad];

    windowArray = [NSMutableArray new];
    
    [self loadFiles];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(viewFile) name:@"EVENT_OPEN" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(closeViewWindow:) name:@"CLOSE_WINDOW" object:nil];
    
    [self.colViewPhoto registerClass:ColViewImage.class forItemWithIdentifier:@"item"];
    self.colViewPhoto.dataSource = self;
    self.colViewPhoto.delegate = self;
    layout = self.colViewPhoto.collectionViewLayout;
    iconWidth = [[NSUserDefaults standardUserDefaults] integerForKey:@"ICON_WIDTH"];
    if(iconWidth <= 0){
        iconWidth = 300;
    }
    _sliderSize.integerValue = iconWidth;
    layout.itemSize = NSMakeSize(iconWidth, iconWidth);
    
    [self refreshBackground:1];
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self.view.window setTitle:APP_NAME];
    });
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(loadFiles) name:@"FILE_CHANGED" object:nil];
    
    [self loadCmds];
    pop2val = [NSMutableDictionary new];
    
    [self loadDropDown:@"Mode" to:self.popMainMode];
    [self loadDropDown:@"Live Stream BitRate" to:self.popLiveBitrate];
    [self loadDropDown:@"Live Stream Window Size" to:self.popLiveWindow];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        //load default
        NSString* str = [[NSUserDefaults standardUserDefaults] stringForKey:@"LVBitRate"];
        if(str != nil){
            [self.popLiveBitrate selectItemWithTitle:str];
        }else{
            
        }
        
        str = [[NSUserDefaults standardUserDefaults] stringForKey:@"LVSize"];
        if(str != nil){
            [self.popLiveWindow selectItemWithTitle:str];
        }else{
            
        }
    });
    
    [self loadSettingPop];
    
    pollingLiveRestart = NO;
    isLiveViewing = NO;
    
    winHero4CP = [[Hero4CodeParing alloc] initWithWindowNibName:@"Hero4CodeParing"];
    
    continueSyncClicked = NO;
    
    dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"yyyy:MM:dd HH:mm:ss"];
    
    NSData* defaultURL = [[NSUserDefaults standardUserDefaults] objectForKey:@"SYNC_FOLDER_PATH"];
    if(defaultURL != nil){
        BOOL stale;
        NSError* error;
        NSURL* url = [NSURL URLByResolvingBookmarkData:defaultURL options:NSURLBookmarkResolutionWithSecurityScope relativeToURL:nil bookmarkDataIsStale:&stale error:&error];
        if(url == nil || stale || error){
            
        }else{
            self.syncPath = [[url.absoluteString stringByReplacingOccurrencesOfString:@"file://" withString:@""]     stringByRemovingPercentEncoding];
            [self.tfSyncStatus setStringValue:_syncPath];
            
            [url startAccessingSecurityScopedResource];
        }
    }
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(progressUpdate:) name:@"DOWNLOAD_PROGRESS" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(usbConnectError:) name:@"USB_CONNECT_ERROR" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(syncDone:) name:@"SYNC_DONE" object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(copyFile:) name:@"COPY_FILE" object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(copyFileDone:) name:@"COPYFILE_DONE" object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(viewWindowClosed:) name:@"CLOSE_WINDOW" object:nil];
    
    tag = 1;
    
    preventUserExit = NO;
}

- (void)viewWindowClosed:(NSNotification*)noti{
    if(noti.object != nil && [windowArray containsObject:noti.object]){
        [windowArray removeObject:noti.object];
    }
}

- (IBAction)lvBitratChanged:(NSPopUpButton*)popup {
     dispatch_async(dispatch_get_main_queue(), ^{
         
    if(self.popLiveBitrate.selectedItem == nil){
        return;
    }
    [[NSUserDefaults standardUserDefaults] setObject:self.popLiveBitrate.selectedItem.title forKey:@"LVBitRate"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    
   
        NSArray* urls = [pop2val objectForKey:popup.identifier];
        urlBitRate = urls[[popup indexOfSelectedItem]];
//        [GoProHelper sendCommand:url completion:^(NSData *d, NSError *e) {
//
//        }];
    });
}

- (IBAction)sliderSizeChanged:(NSSlider*)sender {
    int size = sender.integerValue;
    iconWidth = size;
    layout.itemSize = NSMakeSize(iconWidth, iconWidth);
    [self.colViewPhoto reloadData];
    
    [[NSUserDefaults standardUserDefaults] setInteger:iconWidth forKey:@"ICON_WIDTH"];
    [[NSUserDefaults standardUserDefaults] synchronize];
}

- (IBAction)lvWinSizeChanged:(NSPopUpButton*)popup {
    dispatch_async(dispatch_get_main_queue(), ^{
    if(self.popLiveWindow.selectedItem == nil){
        return;
    }
    
    [[NSUserDefaults standardUserDefaults] setObject:self.popLiveWindow.selectedItem.title forKey:@"LVSize"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    
    
        NSArray* urls = [pop2val objectForKey:popup.identifier];
        urlSize = urls[[popup indexOfSelectedItem]];
//        [GoProHelper sendCommand:url completion:^(NSData *d, NSError *e) {
//
//        }];
    });
}

- (IBAction)upClicked:(id)sender {
    [GoProHelper sendCommand:@"http://10.5.5.9/gp/gpControl/setting/52/1" completion:^(NSData *d, NSError *e) {
        
    }];
}

- (IBAction)downClicked:(id)sender {
    [GoProHelper sendCommand:@"http://10.5.5.9/gp/gpControl/setting/52/2" completion:^(NSData *d, NSError *e) {
        
    }];
}

- (IBAction)GyroClicked:(id)sender {
    [GoProHelper sendCommand:@"http://10.5.5.9/gp/gpControl/setting/52/0" completion:^(NSData *d, NSError *e) {
        
    }];
}

- (void)loadSettingPop{
    [self.popSetName removeAllItems];
    [self.popSetName setTarget:self];
    [self.popSetName setAction:@selector(settingSelected:)];
    
    NSDictionary* drops = [cmds objectForKey:@"dropdown"];
    NSArray * keys= drops.allKeys;
    
    [self.popSetName addItemsWithTitles:[keys sortedArrayUsingSelector:@selector(localizedCaseInsensitiveCompare:)]];
    
    if(keys.count > 0){
        [self loadDropDown:@"Boot Mode" to:self.popSetVal];
    }
}

- (void)settingSelected:(NSPopUpButton*)pop{
    [self loadDropDown:pop.titleOfSelectedItem to:self.popSetVal];
}

- (void)loadDropDown:(NSString*)key to:(NSPopUpButton*)popup{
    [popup removeAllItems];
    NSDictionary* drops = [cmds objectForKey:@"dropdown"];
    NSDictionary* kv = drops[key];
    NSArray* keys = [kv objectForKey:@"key"];
    NSArray* values = kv[@"value"];
    
    NSMutableArray* kk = [NSMutableArray arrayWithArray:keys];
    [kk insertObject:@"" atIndex:0];
    
    NSMutableArray* vv = [NSMutableArray arrayWithArray:values];
    [vv insertObject:@"" atIndex:0];
    
    [popup addItemsWithTitles:kk];
    
    [pop2val setObject:vv forKey:popup.identifier];
    
//    [popup setTarget:self];
//    [popup setAction:@selector(popupSelectionChanged:)];
}

- (void)popupSelectionChanged:(NSPopUpButton*)popup{
    if(popup.titleOfSelectedItem.length == 0){
        return;
    }
    NSArray* urls = [pop2val objectForKey:popup.identifier];
    NSString* url = urls[[popup indexOfSelectedItem]];
    [GoProHelper sendCommand:url completion:^(NSData *d, NSError *e) {
        
    }];
}

- (void)loadCmds{
    NSString* path = [[NSBundle mainBundle] pathForResource:@"cmds" ofType:@"json"];
    NSString* ct = [NSString stringWithContentsOfFile:path encoding:NSUTF8StringEncoding error:nil];
    cmds = [[JSONDecoder new] objectWithUTF8String:ct.cString length:ct.length];    
}

- (IBAction)hero4CodePairing:(id)sender {
    NSAlert *alert = [[NSAlert alloc] init];
    [alert setMessageText:@"1. On camera, Press and hold Settings button until 'Wi-fi Mode' -> Use Power/Mode button to cycle to 'GoPro App' -> Press Shutter/Select button to select it\n 2.On Mac,connect go WIFI name GOPRO-BP-(numbers) password:goprohero\n 3.Enter the  digit PIN on the GoPro front screen:"];
    [alert addButtonWithTitle:@"Pair"];
    [alert addButtonWithTitle:@"Cancel"];
    
    NSTextField *input = [[NSTextField alloc] initWithFrame:NSMakeRect(0, 0, 200, 24)];
    [input setStringValue:@""];
    
    [alert setAccessoryView:input];
    [[NSApplication sharedApplication] activateIgnoringOtherApps:YES];
    [alert.window setInitialFirstResponder:input];    
    NSInteger button = [alert runModal];
    
    if (button == NSAlertFirstButtonReturn) {
        NSString* num = input.stringValue;
        if(num == nil || num.length == 0){
            return;
        }else{
            [GoProHelper sendCommand:
             [NSString stringWithFormat:@"https://10.5.5.9/gpPair?c=start&pin=%@&mode=0",num] completion:^(NSData *data, NSError *err) {
                 dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                     [GoProHelper sendCommand:
                      [NSString stringWithFormat:@"https://10.5.5.9/gpPair?c=finish&pin=%@&mode=0",num] completion:^(NSData *data, NSError *err) {
                          dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                              [self loadFiles];
                          });
                      }];
                 });
            }];
        }
    }
}

-(void)closeViewWindow:(NSNotification*)noti{
    if([windowArray containsObject:noti.object]){
        [windowArray removeObject:noti.object];
    }    
}

NSString* lastFiles;
BOOL isConnected;
- (IBAction)sleepClicked:(id)sender {
    [GoProHelper sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=stop" completion:nil];
    
    [GoProHelper sendCommand:@"http://10.5.5.9/gp/gpControl/command/system/sleep" completion:nil];
}

- (IBAction)displayOnClicked:(NSButton*)sender {
    [GoProHelper sendCommand:
     [NSString stringWithFormat:@"http://10.5.5.9/gp/gpControl/setting/72/%d",sender.state == NSControlStateValueOn?1:0]
                  completion:nil];
}

- (IBAction)LCDOnClicked:(NSButton*)sender {
    [GoProHelper sendCommand:
     [NSString stringWithFormat:@"http://10.5.5.9/gp/gpControl/setting/58/%d",sender.state == NSControlStateValueOn?1:0]
                  completion:nil];
}

int tag;
-(void)startUDPWOL{
    if(udpSocket == nil){
        udpSocket = [[GCDAsyncUdpSocket alloc] initWithDelegate:self delegateQueue:dispatch_get_main_queue()];
        [udpSocket bindToPort:58999 error:nil];
        [udpSocket joinMulticastGroup:@"255.255.255.0" error:nil];
    }
    
    NSData* data = [mac dataUsingEncoding:NSUTF8StringEncoding];
    [udpSocket sendData:data toHost:@"10.5.5.9" port:9 withTimeout:5 tag:tag++];
}

-(void)refreshBackground:(int)seconds{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(seconds * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{        
        [self sendCommand:@"http://10.5.5.9:8080/gp/gpMediaList" completion:^(NSData *data, NSError *error) {
            
            isConnected = (error == nil);
            
            if(isConnected && camName == nil){
                [self sendCommand:@"http://10.5.5.9/gp/gpControl/setting/64/0" completion:nil];
                [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/mode?p=0" completion:nil];
                
                dispatch_async(dispatch_queue_create("hello", nil), ^{
                    NSString* allSet =[NSString stringWithContentsOfURL:
                                       [NSURL URLWithString:@"http://10.5.5.9/gp/gpControl"]  encoding:NSUTF8StringEncoding error:nil];
                    if(allSet == nil){
                        camName = @"Hero2/Hero3/Hero3+";
                        return;
                    }
                    NSDictionary* obj = [[JSONDecoder new] objectWithData:[allSet dataUsingEncoding:NSUTF8StringEncoding]];
                    if(obj != nil && obj[@"info"] != nil){
                        camName = obj[@"info"][@"model_name"];
                        serial = obj[@"info"][@"serial_number"];
                        mac = obj[@"info"][@"ap_mac"];
                        firmware = obj[@"info"][@"firmware_version"];
                        
                        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                            [self.lblStatus setStringValue:[NSString stringWithFormat:@"%@ %@ %@",camName,serial,firmware]];
                        });
                    }
                    
                    [self startUDPWOL];
                });
                if(camName == nil){
                    camName = @"Unknown";
                }
            }
            
//            if(isConnected){
//                [self lvBitratChanged:self.popLiveBitrate];
//                [self lvWinSizeChanged:self.popLiveWindow];
//            }
            
            if(error != nil){
                //NSLog(@"%@",error.localizedDescription);
                isConnected = NO; camName = nil;
                
                dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                    [self.lblStatus setStringValue:@"Connecting ... , please wake up or start your GoPro (LCD is on) and connect to your GoPro WIFI network."];
                    [self.btnHero4CP setHidden:NO];
                });
                
                [self refreshBackground:5];
            }else{
                NSString* json = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
                
                if(json != nil && json.length > 0){
                    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                        [self.btnHero4CP setHidden:YES];
                    });
                }
                
                if(lastFiles != nil && [lastFiles isEqualToString:json]){
                    [self refreshBackground:5];
                    
                    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                        [self.lblStatus setStringValue:@"Connected"];
                        if(firmware != nil){
                            [self.lblStatus setStringValue:[NSString stringWithFormat:@"%@ %@ %@",camName,serial,firmware]];
                        }
                        
                    });
                }else{
                    [self processFiles:json];
                    [self refreshBackground:15];
                    
                    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                        [self.lblStatus setStringValue:@"Connected ..."];
                    });
                }
                lastFiles = json;
            }
            
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [self.btnLiveView setEnabled:!isSaving && isConnected];
                [self.btnSaveLiveView setEnabled:!isLiveViewing && isConnected];
                [self.btnStop  setEnabled:isConnected];
                [self.btnStart  setEnabled:isConnected];
                [self.btnSleep setEnabled:isConnected];
                [self.btnRefresh setEnabled:isConnected];
            });
        }];
    });
}

- (void)loadFiles{
    //    NSString* ct = [NSString stringWithContentsOfURL:[NSURL URLWithString:@"http://10.5.5.9:8080/gp/gpMediaList"] encoding:NSUTF8StringEncoding error:nil];
    
    [self sendCommand:@"http://10.5.5.9:8080/gp/gpMediaList" completion:^(NSData *data, NSError *error) {
        if(error != nil){
            //NSLog(@"%@",error.localizedDescription);
            return;
        }else{
            [self processFiles:[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding]];
        }
    }];
}

- (void)poolingResart{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        NSString* ct = [NSString stringWithContentsOfURL:[NSURL URLWithString:@"http://10.5.5.9/gp/gpControl/status"] encoding:NSUTF8StringEncoding error:nil];
        if(ct != nil &&
           [ct rangeOfString:@"\"32\":1"].location == NSNotFound){
            [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" completion:nil];
        }
        
        if(pollingLiveRestart){
            [self poolingResart];
        }
    });
}

- (IBAction)saveLiveViewClicked:(id)sender {
    if(isSaving){
//        [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" completion:nil];
        
        if(queueSave != nil){
//            dispatch_suspend(queueSave);
            sigterm_handler(1414092869);
//            received_sigterm = 1414092869;
//            term_exit();
        }
        
        [self.btnSaveLiveView setTitle:@"Save LiveView"];
        isSaving = NO;
        
        [[NSApplication sharedApplication] terminate:self];
        
        return;
    }
    
    [self lvWinSizeChanged:self.popLiveWindow];
    [self lvBitratChanged:self.popLiveBitrate];
    
    [self sendCommand:urlBitRate completion:nil];
    [self sendCommand:urlSize completion:nil];
        
    [self saveLiveView];
}

- (void)saveLiveView{
    NSOpenPanel *savePanel = [NSOpenPanel openPanel];
    [savePanel setCanCreateDirectories:YES];
    [savePanel setCanChooseFiles:NO];
    [savePanel setCanChooseDirectories:YES];
    [savePanel setAllowsMultipleSelection:NO];
    
    [savePanel beginWithCompletionHandler:^(NSInteger result){
        if (result == NSFileHandlingPanelOKButton) {
            
            [self.btnSaveLiveView setTitle:@"Stop Save"];
            [self.btnLiveView setEnabled:NO];
            
            pollingLiveRestart = YES;
            [self poolingResart];
            
            isSaving = YES;
            
            NSString* saveFile = savePanel.URL.absoluteString;
            
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [[NSWorkspace sharedWorkspace] openURL: savePanel.URL];
            });
            
            if([self isHero3]){
                [self saveHero3LiveViewTo:saveFile];
            }else{
                [self saveLiveViewTo:saveFile];
            }
        }
    }];
}

///gp/gpControl/execute?p1=gpStream&c1=stop

-(void)saveHero3LiveViewTo:(NSString*)path{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        
        
        if(files.count<=0){
            return;
        }
       
        
        if(queueSave == nil){
            queueSave = dispatch_queue_create("com.woiapp.gopro.saveLiveView", NULL);
        }
        
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), queueSave, ^{
            const char* array[] = {
                "main"
                ,"-i"
                ,"http://10.5.5.9:8080/live/amba.m3u8"
                ,"-f"
                ,"segment"
                ,"-segment_time"
                ,"30"
                ,"-segment_format"
                ,"mpegts"
                ,"-framerate"
                ,"30"
                ,[[path stringByAppendingString:@"capture-%3d.ts"] cStringUsingEncoding:NSUTF8StringEncoding]
            };
            
            
            int savedStdOut = dup(STDOUT_FILENO);
            int savedStdError = dup(STDERR_FILENO);
            //        NSString *cachesDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) objectAtIndex:0];
            NSString *cachesDirectory = NSTemporaryDirectory();
            NSString *logErrorPath = [cachesDirectory stringByAppendingPathComponent:@"e"];
            NSString *logOutPath = [cachesDirectory stringByAppendingPathComponent:@"o"];
#if DEBUG
            //NSLog(@"-----------%@",logErrorPath);
#endif
            freopen([logOutPath cStringUsingEncoding:NSASCIIStringEncoding], "w", stdout);
            freopen([logErrorPath cStringUsingEncoding:NSASCIIStringEncoding], "w", stderr);
            
            main556(sizeof(array) / sizeof (const char *),array);
            
            fflush(stdout);
            fflush(stderr);
            dup2(savedStdOut, STDOUT_FILENO);
            dup2(savedStdError, STDERR_FILENO);
            close(savedStdError);
            close(savedStdOut);            
        });
        
    });
}

-(void)saveLiveViewTo:(NSString*)path{
     //check status "32":1
    [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/mode?p=0" completion:nil];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/shutter?p=0" completion:^(NSData *data, NSError *error) {}];
    });  
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" completion:nil];
    });
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
           
        
    if(files.count<=0){
        return;
    }
//    [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/mode?p=0" completion:nil];
//
//    [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" completion:nil];
    
//    return;
    pollingLiveRestart = YES;
    [self poolingResart];
    
    //ffmpeg -i 'udp://:8554' -acodec aac -vcodec h264 -fflags nobuffer -f:v mpegts -probesize 8192 -analyzeduration 5  -f segment -segment_time 30 -segment_format mp4 "capture-%03d.mp4"
    
    if(queueSave == nil){
        queueSave = dispatch_queue_create("com.woiapp.gopro.saveLiveView", NULL);
    }
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), queueSave, ^{
        const char* array[] = {
      "main"
            ,"-i"
            ,"udp://:8554"
            
        ,"-vcodec"
        ,"h264"
        ,"-acodec"
        ,"aac"
            ,"-fflags"
            ,"nobuffer"
            ,"-analyzeduration"
            ,"5"
            ,"-probesize"
            ,"8192"
            
        ,"-f"
        ,"segment"
        ,"-segment_time"
        ,"30"
            ,"-segment_format"
            ,"mpegts"
        ,"-framerate"
        ,"30"
        ,[[path stringByAppendingString:@"capture-%3d.ts"] cStringUsingEncoding:NSUTF8StringEncoding]
        };
        
        
        int savedStdOut = dup(STDOUT_FILENO);
        int savedStdError = dup(STDERR_FILENO);
//        NSString *cachesDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSString *cachesDirectory = NSTemporaryDirectory();
        NSString *logErrorPath = [cachesDirectory stringByAppendingPathComponent:@"e"];
        NSString *logOutPath = [cachesDirectory stringByAppendingPathComponent:@"o"];
#if DEBUG
        //NSLog(@"-----------%@",logErrorPath);
#endif
        freopen([logOutPath cStringUsingEncoding:NSASCIIStringEncoding], "w", stdout);
        freopen([logErrorPath cStringUsingEncoding:NSASCIIStringEncoding], "w", stderr);
        
        main556(sizeof(array) / sizeof (const char *),array);
        
        fflush(stdout);
        fflush(stderr);
        dup2(savedStdOut, STDOUT_FILENO);
        dup2(savedStdError, STDERR_FILENO);
        close(savedStdError);
        close(savedStdOut);
        
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=stop" completion:nil];        
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/setting/64/0" completion:nil];
    });
        
    });
}

- (IBAction)hero4CPClicked:(id)sender {
    [winHero4CP showWindow:self];
}

- (IBAction)liveViewClicked:(id)sender {
    if(isLiveViewing){
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" completion:nil];
        return;
    }
    
    pollingLiveRestart = YES;
    [self poolingResart];
    
//    [self.btnLiveView setEnabled:NO];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(15 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
//        [self.btnLiveView setEnabled:YES];
    });
    
    [self lvWinSizeChanged:self.popLiveWindow];
    [self lvBitratChanged:self.popLiveBitrate];
    
    isLiveViewing = YES;
    [self.btnSaveLiveView setEnabled:NO];
    [self showCamera];
//    [self startUDP];
}

- (BOOL)isHero3{
    if(camName != nil && [camName.lowercaseString rangeOfString:@"hero3"].location != NSNotFound){
        return YES;
    }
    return NO;
}

- (void)showHero3Live{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        int savedStdOut = dup(STDOUT_FILENO);
        int savedStdError = dup(STDERR_FILENO);
        //        NSString *cachesDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSString *cachesDirectory = NSTemporaryDirectory();
        NSString *logErrorPath = [cachesDirectory stringByAppendingPathComponent:@"e"];
        NSString *logOutPath = [cachesDirectory stringByAppendingPathComponent:@"o"];
#if DEBUG
        //NSLog(@"-----------%@",logErrorPath);
#endif
        freopen([logOutPath cStringUsingEncoding:NSASCIIStringEncoding], "w", stdout);
        freopen([logErrorPath cStringUsingEncoding:NSASCIIStringEncoding], "w", stderr);
        
        
        char** args = malloc(2 * sizeof(char*));
        args[0] = "main";
        args[1] = "http://10.5.5.9:8080/live/amba.m3u8";
//        args[2] = "-analyzeduration";
//        args[3] = "5";
//        args[4] = "-probesize";
//        args[5] = "8192";
//        args[6] = "-acodec";
//        args[7] = "aac";
//        args[8] = "-vcodec";
//        args[9] = "h264";
//        args[10] = "-fflags";
//        args[11] = "nobuffer";
//        args[12] = "-f:v";
//        args[13] = "mpegts";
        main234(2,args);
        
        //        char** args = malloc(4 * sizeof(char*));
        //        args[0] = "main";
        //        args[1] = "-fflags";
        //        args[2] = "nobuffer";
        //        args[3] = "udp://:8554";
        //        main234(4,args);
        
        fflush(stdout);
        fflush(stderr);
        dup2(savedStdOut, STDOUT_FILENO);
        dup2(savedStdError, STDERR_FILENO);
        close(savedStdError);
        close(savedStdOut);
        //        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        //            [NSString stringWithContentsOfURL:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" encoding:NSUTF8StringEncoding error:nil];
        //
        
        //        });
        
        
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=stop" completion:nil];
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/setting/64/0" completion:nil];
    });
}

- (void)showCamera{
    if([self isHero3]){
//        http://10.5.5.9:8080/live/amba.m3u8
        [self showHero3Live];
        return;
    }
    
    //set mode to video
    [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/mode?p=0" completion:nil];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/shutter?p=0" completion:^(NSData *data, NSError *error) {}];
    });
    
    [self sendCommand:urlBitRate completion:nil];
    [self sendCommand:urlSize completion:nil];
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" completion:nil];
    });
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        if(files.count<=0){
            return;
        }
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" completion:nil];
        
        
        int savedStdOut = dup(STDOUT_FILENO);
        int savedStdError = dup(STDERR_FILENO);
        //        NSString *cachesDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) objectAtIndex:0];
        NSString *cachesDirectory = NSTemporaryDirectory();
        NSString *logErrorPath = [cachesDirectory stringByAppendingPathComponent:@"e"];
        NSString *logOutPath = [cachesDirectory stringByAppendingPathComponent:@"o"];
#if DEBUG
        //NSLog(@"-----------%@",logErrorPath);
#endif
        freopen([logOutPath cStringUsingEncoding:NSASCIIStringEncoding], "w", stdout);
        freopen([logErrorPath cStringUsingEncoding:NSASCIIStringEncoding], "w", stderr);
        
        
        char** args = malloc(14 * sizeof(char*));
        args[0] = "main";
        args[1] = "udp://:8554";
        args[2] = "-analyzeduration";
        args[3] = "5";
        args[4] = "-probesize";
        args[5] = "8192";
        args[6] = "-acodec";
        args[7] = "aac";
        args[8] = "-vcodec";
        args[9] = "h264";
        args[10] = "-fflags";
        args[11] = "nobuffer";
        args[12] = "-f:v";
        args[13] = "mpegts";
        main234(14,args);

//        char** args = malloc(4 * sizeof(char*));
//        args[0] = "main";
//        args[1] = "-fflags";
//        args[2] = "nobuffer";
//        args[3] = "udp://:8554";
//        main234(4,args);
        
        fflush(stdout);
        fflush(stderr);
        dup2(savedStdOut, STDOUT_FILENO);
        dup2(savedStdError, STDERR_FILENO);
        close(savedStdError);
        close(savedStdOut);
        //        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        //            [NSString stringWithContentsOfURL:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart" encoding:NSUTF8StringEncoding error:nil];
        //
        
        //        });
        
        
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=stop" completion:nil];
        [self sendCommand:@"http://10.5.5.9/gp/gpControl/setting/64/0" completion:nil];
    });
}

- (IBAction)startClicked:(id)sender {
//    [self popupSelectionChanged:_popMainMode];
    
//    [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/shutter?p=0" completion:^(NSData *data, NSError *error) {}];
    
//    NSString* ct = [NSString stringWithContentsOfURL:[NSURL URLWithString:@"http://10.5.5.9/gp/gpControl/status"] encoding:NSUTF8StringEncoding error:nil];
//    if(ct != nil &&
//       [ct rangeOfString:@"\"32\":1"].location != NSNotFound){
//        pollingLiveRestart = NO;
//        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
//            [self startClicked:sender];
//        });
//        return;
//    }
    [self sendCommand:@"http://10.5.5.9/gp/gpControl/setting/64/0" completion:nil];
    
    [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/shutter?p=1" completion:^(NSData *data, NSError *error) {
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            int now = files.count;
            [self refreshData:nil];
            if(now == files.count){
                dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                });
            }
        });
    }];
}

- (IBAction)stopClicked:(id)sender {
    [self sendCommand:@"http://10.5.5.9/gp/gpControl/command/shutter?p=0" completion:^(NSData *data, NSError *error) {
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            int now = files.count;
            [self refreshData:nil];
            if(now == files.count){
                dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                });
            }
        });
    }];
}

- (IBAction)refreshData:(id)sender {
    [self loadFiles];
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_queue_create("hello", nil), ^{
        [NSString stringWithContentsOfURL:[NSURL URLWithString:@"http://10.5.5.9/gp/gpControl/execute?p1=gpStream&a1=proto_v2&c1=restart"]  encoding:NSUTF8StringEncoding error:nil];
    });
}

- (void)sendCommand:(NSString*)urlString completion:(void (^)(NSData *, NSError *))block{
    [GoProHelper sendCommand:urlString completion:block];
}

- (void)processFiles:(NSString*)ct{
    lastFiles = ct;
    
    NSDictionary* obj = [[JSONDecoder new] objectWithUTF8String:ct.cString length:ct.length];
    if(obj == nil){
        return;
    }
    NSArray* media = [obj objectForKey:@"media"];
    if(media == nil){
        return;
    }
    
    files = [NSMutableArray new];
    for(int i=0;i<media.count;i++){
        NSDictionary* d = media[i];
        NSString* dirName = [d objectForKey:@"d"];
        NSArray* fs = [d objectForKey:@"fs"];
        //NSLog(@"dir %@",dirName);
        
        for(int i=0;i<fs.count;i++){
            NSDictionary* fi = fs[i];
            NSString* n = [fi objectForKey:@"n"];
            NSString* s = [fi objectForKey:@"s"];
            NSString* ls = [fi objectForKey:@"ls"];
            NSString* mod = [fi objectForKey:@"mod"];
            
            //NSLog(@"%@,%@,%@,%@",n,s,ls,mod);
            
            MediaFile* mf = [MediaFile new];
            mf.dir = dirName;
            mf.name = n;
            
            [files addObject:mf];
            //get meta
        }
    }
    
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.colViewPhoto reloadData];
    });    
}

- (void)processMeta:(NSString*)path{
//    http://10.5.5.9:8080/gp/gpMediaMetadata?p=XXXGOPRO/GOPRXXXX.MP4&t=videoinfo
    //{"dur":"20","avc_profile":"100","profile":"50","tag_count":4,"tags":[1200,4330,5000,7400]}
//  http://10.5.5.9:8080/gp/gpMediaMetadata?p=XXXGOPRO/GOPRXXXX.MP4
}


- (NSInteger)collectionView:(NSCollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    return files.count;
}

- (NSCollectionViewItem *)collectionView:(NSCollectionView *)collectionView itemForRepresentedObjectAtIndexPath:(NSIndexPath *)indexPath{
    
        ColViewImage* cvi = [collectionView makeItemWithIdentifier:@"item" forIndexPath:indexPath];;
        cvi.tag = [indexPath indexAtPosition:1];
        MediaFile* mf = [files objectAtIndex:cvi.tag];
        [cvi setFile:mf];
        [cvi setImage:[mf getThumbnailPath]];
        [cvi setTitle:mf.getDownloadURL.lastPathComponent];
        return cvi;    
}

//
//NSAlert *alert = [[NSAlert alloc] init];
//[alert setMessageText:@"Please enter IP address of your Sonos:"];
//[alert addButtonWithTitle:@"Ok"];
//[alert addButtonWithTitle:@"Cancel"];


int selIdx;

- (void)viewFile{
    MediaFile* mf = [files objectAtIndex:selIdx];
    
    ViewWindowController* vwc;
    
    vwc = [[ViewWindowController alloc] initWithWindowNibName:@"ViewWindowController"];
    vwc.mf = mf;    
    [vwc showWindow:self];
    [vwc.window setTitle:[NSString stringWithFormat:@"%@",mf.name]];
    
    [windowArray addObject:vwc];
}

- (void)setRepresentedObject:(id)representedObject {
    [super setRepresentedObject:representedObject];

    // Update the view, if already loaded.
}



- (IBAction)toFolderClicked:(id)sender {
    NSOpenPanel *openPanel = [NSOpenPanel openPanel];
    [openPanel setCanCreateDirectories:YES];
    [openPanel setCanChooseFiles:NO];
    [openPanel setCanChooseDirectories:YES];
    [openPanel setAllowsMultipleSelection:NO];
    
    if(self.syncPath != nil){
        [openPanel setDirectoryURL:[NSURL URLWithString:self.syncPath]];
    }
    
    [openPanel beginWithCompletionHandler:^(NSInteger result){
        if (result == NSFileHandlingPanelOKButton) {
            NSURL* url = openPanel.URL;
            NSError* err;
            NSData* urlData = [url bookmarkDataWithOptions:NSURLBookmarkCreationWithSecurityScope includingResourceValuesForKeys:nil relativeToURL:nil error:&err];
            if(err != nil){
                //NSLog(@"error: %@",err.localizedDescription);
            }
            [[NSUserDefaults standardUserDefaults] setObject:urlData forKey:@"SYNC_FOLDER_PATH"];
            [[NSUserDefaults standardUserDefaults] synchronize];
            
            [self.tfSyncStatus setStringValue:url.path];
            self.syncPath = url.path;
            
            if(continueSyncClicked){
                [self usbSyncClicked:nil];
            }
            
            continueSyncClicked = NO;
        }
    }];
    
    continueSyncClicked = NO;
}

int tryTime;
int syncStatus;
BOOL syncFile;

extern NSString* currentPath;

- (IBAction)usbSyncClicked:(id)sender {
    if(self.syncPath == nil){
        continueSyncClicked = YES;
        [self toFolderClicked:nil];
        return;
    }
    
    [self.progInd setMinValue:0];
    [self.progInd setMaxValue:100];
    [self.progInd setDoubleValue:0];
    
    if(syncStatus == 1){
        [self.tfSyncStatus setStringValue:self.syncPath];
        syncStatus = 0;
        return;
    }
    
    tryTime=0;
    syncStatus = 1;
    syncFile = NO;
    
    currentPath = self.syncPath;
    //    NSError* error;
    //    [@"hello" writeToFile:[currentPath stringByAppendingPathComponent:@"test.txt"] atomically:YES encoding:NSUTF8StringEncoding error:&error];
    //    if(error != nil){
    //        //NSLog(error.localizedDescription);
    //        return;
    //    }
    
    dispatch_queue_t main = dispatch_get_main_queue();
    dispatch_async(dispatch_queue_create("com.woiapp", 0), ^{
        [self dispatchSync];
    });
}

- (void)progressUpdate:(NSNotification*)noti{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        NSNumber* num = noti.object;
        
        if(!syncFile){
            syncFile = YES;
            [[NSWorkspace sharedWorkspace]openFile:self.syncPath withApplication:@"Finder"];
        }
        [_progInd setDoubleValue:num.doubleValue];
    });
}

-(void)usbConnectError:(NSNotification*)noti{
    dispatch_queue_t main = dispatch_get_main_queue();
    dispatch_async(dispatch_queue_create("com.woiapp", 0), ^{
        syncStatus = 1;
        tryTime = 0;
        [self dispatchSync];
    });
}

-(void)syncDone:(NSNotification*)noti{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self.btnSync setEnabled:YES];
        [self.tfSyncStatus setStringValue:@"Done."];
        tryTime = 0;
        syncStatus = 0;
    });
}

-(void)copyFileDone:(NSNotification*)noti{
    NSString* path = noti.object;
    if(path == nil || ![[NSFileManager defaultManager] isReadableFileAtPath:path]){
        return;
    }
    
    if(noti.userInfo != nil){
        NSDictionary *attrs = [NSDictionary dictionaryWithObjectsAndKeys:
                               [noti.userInfo objectForKey:@"create"]
                               ,NSFileCreationDate
                               ,[noti.userInfo objectForKey:@"modify"]
                               ,NSFileModificationDate
                               ,nil];
        NSError *errorFile;
        if ([[NSFileManager defaultManager] setAttributes:attrs ofItemAtPath:path error: &errorFile])
        {
            //            //NSLog(@"Set timestamp of file");
        }
        else {
            //NSLog(@"COULD NOT set timestamp of file %@",path);
        }
        
        return;
    }
    
    
    if(! ([path.pathExtension.lowercaseString isEqualToString:@"jpg"]
          || [path.pathExtension.lowercaseString isEqualToString:@"png"]
          || [path.pathExtension.lowercaseString isEqualToString:@"heic"]
          )
       ){
        
        //        MDItemRef fileMetadata=MDItemCreate(NULL,(CFStringRef)eachPath);
        //        NSDictionary *metadataDictionary = (NSDictionary*)MDItemCopyAttributes (fileMetadata,
        //                                                                                (CFArrayRef)[NSArray arrayWithObjects:(id)kMDItemPixelHeight,(id)kMDItemPixelWidth,nil]);
        //
        //NSLog(@"can't process %@",path);
        return;
    }
    
    dispatch_async(dispatch_queue_create("woiapp", 0),^{
        //get exif date time
        NSString* dateStr;
        
        NSURL *imageFileURL = [NSURL fileURLWithPath:path];
        CGImageSourceRef img = CGImageSourceCreateWithURL((CFURLRef)imageFileURL, NULL);
        
        if(img == nil){
            return;
        }
        CFDictionaryRef dict = CGImageSourceCopyPropertiesAtIndex(img,0,nil);
        CFRelease(img);
        if(dict == nil){
            return;
        }
        NSDictionary* dictdict = [NSDictionary dictionaryWithDictionary:(__bridge NSDictionary*)(dict)];
        NSDictionary* tiff =  [dictdict objectForKey:kCGImagePropertyTIFFDictionary];
        if(tiff == nil){
            return;
        }
        dateStr = [tiff objectForKey:kCGImagePropertyTIFFDateTime];
        
        if(dateStr == nil || dateStr.length < 5){
            return;
        }
        
        NSDate* date = [dateFormatter dateFromString:dateStr];
        
        if(date == nil){
            return;
        }
        
        NSDictionary *attrs = [NSDictionary dictionaryWithObjectsAndKeys:
                               date
                               ,NSFileCreationDate
                               ,date
                               ,NSFileModificationDate
                               ,nil];
        NSError *errorFile;
        if ([[NSFileManager defaultManager] setAttributes:attrs ofItemAtPath:path error: &errorFile])
        {
            //            //NSLog(@"Set timestamp of file");
        }
        else {
            //NSLog(@"COULD NOT set timestamp of file %@",path);
        }
    });
}

-(void)copyFile:(NSNotification*)noti{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.01 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self.tfSyncStatus setStringValue:[NSString stringWithFormat:@"copy file %@",noti.object]];
    });
}

extern bool preventUserExit;
-(void)dispatchSync{
    preventUserExit = NO;
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self.btnSync setEnabled:NO];
        [self.tfSyncStatus setStringValue:[NSString stringWithFormat:@"trying USB connect... %d",tryTime]];
    });
    
    if(listFilesMTP() != 0){
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            [self.btnSync setEnabled:YES];
        });
        
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_queue_create("com.woiapp", 0), ^{
            tryTime ++;
            
            if(syncStatus == 1){
                [self dispatchSync];
            }
        });
    }else{
        tryTime = 0;
        syncStatus = 0;
        
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            [self.btnSync setEnabled:NO];
        });
    }
    
    
    //    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
    //        [self.btnSync setEnabled:YES];
    //        [self.tfSyncStatus setStringValue:self.syncPath];
    //    });
}

@end
